//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  TRichEdit ̓evr[R|[lgŕ\
//  (őΉR[h)
//  TRichEdit \Ŏs
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2009N0904 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, plPrev, RichEdit, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TSpeedButton;
    RichEdit1: TRichEdit;
    plPrev1: TplPrev;
    OpenDialog1: TOpenDialog;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
  private
    procedure RichEditPrint(X1, X2, Y1, Y2: Integer ; Rich: TRichEdit);
  public
    { Public 錾 }
  end;

  function MiliToTwips(V: Integer): Integer;
  function TwipsToMili(V: Integer): Integer; 
   
var
  Form1: TForm1;

implementation

type
  TPrev = class(TCustomplPrev);

{$R *.DFM}

//=============================================================================
//  [vr[] {^ňvr[Jn
//  ǂݕȂ̂ŁC`R[ȟŃvr[
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LFilePath    : string;
  LPaperWidth  : Integer;
  LPaperHeight : Integer; 
begin
  // ݂̃v^̐ݒ TplSetPrinter R|̒lƂĎ擾
  plPrev1.plSetPrinter.GetPrinterInfo;
  // TplSetPrinter ̏ɂėpTCỸvpeBZbg
  TPrev(plPrev1).SetPaperInfo;

  //  pTCY (0.1 mm P) 擾Ă
  LPaperWidth  := plPrev1.PaperWidth;
  LPaperHeight := plPrev1.PaperHeight;
  

  OpenDialog1.InitialDir := ExpandFileName('..\');
  if not OpenDialog1.Execute then exit;

  LFilePath := OpenDialog1.FileName;
  if FileExists(LFilePath) then begin
    Update;
    Screen.Cursor := crHourGlass;
    RichEdit1.Lines.LoadFromFile(LFilePath);

    plPrev1.Title := 'eXg';
  // ̈w肵Ĉ
    RichEditPrint(300, LPaperWidth - 300, 350, LPaperHeight - 300, RichEdit1);

    if CheckBox1.Checked then begin
      plPrev1.Print;
    end else begin
      plPrev1.ShowModal;
    end;
    Screen.Cursor := crDefault;
  end;
end;

//=============================================================================
//  TRichEdit ̓e`
//  X1       : `̈̍[ X Wl (0.1 mm P)
//  X2       : `̈̉E[ X Wl (0.1 mm P)
//  Y1       : `̈̏[ Y Wl (0.1 mm P)
//  Y2       : `̈̉[ Y Wl (0.1 mm P)
//  RichEdit : TRichEdit
//
//  ̕łɂ킽Ĉ\Ȃ悤ɁCǂݕ̃R[h
//  TplPrev ł͕Ŗɕ`Pʂ 0.1 mm ɂȂ悤Ƀ}bv[hݒ肵Ă
//  }bv[hȂǂ̐ݒ͕ŖɎsKv
//  ǉ`R[h̓}bv[h 0.1 mm PʂɂȂĂԂŎsKv
//=============================================================================
procedure TForm1.RichEditPrint(X1, X2, Y1, Y2: Integer; Rich: TRichEdit);
var
  LRange     : TFormatRange;
  LMaxLen    : Integer;
  LNextIndex : Integer;
  LOldMap    : Integer;

  //---------------------------------------------------------------------------
  //  Windows XP,Vista  Unicode ł̃eLXg{bNX (TRichEdit) ̃oO΍
  //  EM_FORMATRANGE bZ[W𑗂ĂCŌ̕ł̏o͌C̈̃C
  //  fbNXCÕCfbNX -1 ƂȂĂ܂
  //  oOCꂽꍇlāC
  //  MSDN ̃TvR[hƓ LMaxLen łrĕI𔻒肵Ă
  //---------------------------------------------------------------------------
  function GetNextCharIndex: Integer;
  var
    LIndex   : Integer;
    LNextIdx : Integer;
  begin
    LIndex := SendMessage(Rich.Handle, EM_FORMATRANGE, 1, Longint(@LRange));
    LRange.chrg.cpMin := LIndex;
    LNextIdx := SendMessage(Rich.Handle, EM_FORMATRANGE, 0, Longint(@LRange));

    if (LNextIdx < LIndex) or (LIndex > LMaxLen) or (LIndex = 0) then begin
      Result := -1;
    end else begin
      Result := LIndex;
    end;
  end;
  //---------------------------------------------------------------------------

begin
  LNextIndex := 0;

  // Ώە ( Unicode łł̓oCg)
  LMaxLen := Rich.GetTextLen;
  // eLXg̍ŏ
  LRange.chrg.cpMin := LNextIndex;

  plPrev1.BeginDoc;
  try
    plPrev1.FontHeight(60);
    plPrev1.TextOut(200, 200, 'b`GfBg̈');

    // obt@̃tbV
    SendMessage(Rich.Handle, EM_FORMATRANGE, 0, 0);

    //  LRange ɃZbg
    while True do begin

      // wb_

      // Range 0 (null) Ŗ߂
      FillChar(LRange, SizeOf(TFormatRange), 0);
      // o͐foCX̃nh
      LRange.hdc := plPrev1.Canvas.Handle;
      // ݒ肷foCX̃nh
      LRange.hdcTarget := LRange.hdc;

      // `̈̎w (Twips P)
      // ŏ̕łʒuȂǂύXꍇ͕򏈗
      LRange.rc.Left   := MiliToTwips(X1);
      LRange.rc.Right  := MiliToTwips(X2);
      LRange.rc.Top    := MiliToTwips(Y1);
      LRange.rc.Bottom := MiliToTwips(Y2);
      // p 1 ł̃TCY
      // {͗pTCY Twips Ŏw肷ׂ?
      LRange.rcPage := LRange.rc;
      // Ō܂ (-1ŎvZ)
      LRange.chrg.cpMax := -1;

      //}bv[hMM_TEXTɂđÕ}bv[hۑ
      LOldMap := SetMapMode(LRange.hdc, MM_TEXT);

      try
        // ̕ł̊Jn͑O̍Ō̕
        LRange.chrg.cpMin := LNextIndex;
        // ۂ̈Ǝ̈Jnʒu擾
        LNextIndex := GetNextCharIndex;
      finally
        // obt@̃tbV
        SendMessage(Rich.Handle, EM_FORMATRANGE, 0, 0);
        // }bv[hɖ߂
        // TplPrev ł 0.1 mm Pʂɖ߂Ƃ
        SetMapMode(LRange.hdc, LOldMap);
        TPrev(plPrev1).ScaleInitialize(plPrev1.Canvas, False);
      end;

      // tb^

      if LNextIndex < 0 then break;

      plPrev1.NewPage;
    end;

    // SĂ̈Iǉ
    // Ïʒu Twips (LRange.rc.Bottom) Ȃ̂ mm ɊZ
    // s TRichEdit ̕Ɋ܂܂̂Œ
    plPrev1.Canvas.Font.Size := 20;
    plPrev1.Canvas.TextOut(200, TwipsToMili(LRange.rc.Bottom), '̍s');
  finally
    plPrev1.EndDoc;
  end;
end;

//-----------------------------------------------------------------------------
//  0.1 mm Pʂ̍Wl Twips lɕϊ֐
//
//  Ql
//  1 [inch] = 72 [pt]
//  1 [inch] = 1440 [Twips]
//  1 [pt]   = 20 [Twips]
//  1 [inch] = 25.4 [mm]
//   x mm  pt (|Cg) ɊZ鎮
//     pt := x * 72 / 25.4
//
//  ̌vZ TplPrev R|p.ʓIȊZ̓v^̉𑜓x̍lKv
//-----------------------------------------------------------------------------
function MiliToTwips(V: Integer): Integer;
begin
  Result := Trunc(V * 1440.0 / 254.0);
end;

//-------------------------------------------------------------------------------
//  Twips Pʂ̒l 0.1 mm Pʂ̍Wlɕϊ֐
//  ̌vZTplPrevR|p.ʓIȊZ̓v^̉𑜓x̍lKv
//-------------------------------------------------------------------------------
function TwipsToMili(V: Integer): Integer;
begin
  Result := Trunc(V * 254.0 / 1440)
end;

end.
