//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  TRichEdit e (vr[Ȃ)
//  TRichEdit.Print, TRichEdit.PageRect gp@
//  vCeLXg̈\
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2020N0421 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, RichEdit, ComCtrls, plSetPrinter;

type
  TForm1 = class(TForm)
    Button1: TSpeedButton;
    RichEdit1: TRichEdit;
    PrinterSetupDialog1: TPrinterSetupDialog;
    plSetPrinter1: TplSetPrinter;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

  function mmToPixelsX(ASetPrt: TplSetPrinter; AValue: Integer): Integer;
  function mmToPixelsY(ASetPrt: TplSetPrinter; AValue: Integer): Integer;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//=============================================================================
//  TRichEdit (teLXg) ̓Ǎ
//  [h̕ RTF `ŕۑĂΓǍ݉\
//
//  vCeLXg (ȂeLXg) ǂݍň\
//  TRichEdit  TMemo ̑ɎgpăvCeLXg\ꍇ
//  ȉ̐ݒŎgpmȂ
//  PlainText ̓ftHg False ̂܂܂ł悢CۑꍇɖƂȂ
//
//  TRichEdit.ScrollBars := ssVertical;
//  TRichEdit.WordWrap   := True;
//  TRichEdit.PlainText  := True;
//=============================================================================
procedure TForm1.FormShow(Sender: TObject);
var
  LFilePath : string;
begin
  LFilePath := ExpandFileName('..\RichText.RTF');
  if FileExists(LFilePath) then begin
    RichEdit1.Lines.LoadFromFile(LFilePath);
    Self.Width  := 750;
    Self.Height := 500;
  end;
end;

//=============================================================================
//  TRichEdit.Print \bhŗ]ݒ肵Ĉ
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LRect : TRect;
begin
  if not PrinterSetupDialog1.Execute then Exit;

  // ݂̃v^̐ݒ擾
  plSetPrinter1.GetPrinterInfo;
  
  // ̗]ݒD]̓sNZP)
  LRect.Left   := mmToPixelsX(plSetPrinter1, 25);
  LRect.Top    := mmToPixelsY(plSetPrinter1, 30);
  LRect.Right  := plSetPrinter1.PaperWidth  - mmToPixelsX(plSetPrinter1, 25);
  LRect.Bottom := plSetPrinter1.PaperHeight - mmToPixelsY(plSetPrinter1, 30);

  RichEdit1.PageRect := LRect;
  RichEdit1.Print('eXg');
end;

//-----------------------------------------------------------------------------
//  mm Pʂ TPrinter.Canvas ̃sNZɕϊ
//  p
//-----------------------------------------------------------------------------
function mmToPixelsX(ASetPrt: TplSetPrinter; AValue: Integer): Integer;
begin
  Result := Trunc(AValue * ASetPrt.XResolution / 25.4);
end;

//-----------------------------------------------------------------------------
//  mm Pʂ TPrinter.Canvas ̃sNZɕϊ
//  cp
//-----------------------------------------------------------------------------
function mmToPixelsY(ASetPrt: TplSetPrinter; AValue: Integer): Integer;
begin
  Result := Trunc(AValue * ASetPrt.YResolution / 25.4);
end;

end.
